<!--
    Input:
        vendor_framework_compatibility_matrix.xml
        framework_compatibility_matrix.xml
        secure_device_framework_compatibility_matrix.xml
        framework_compatibility_matrix.xml
        device_framework_compatibility_matrix.xml
        vendor.samsung.hardware.tlc.kg@1.0-matrix.xml
        framework_compatibility_matrix.xml
        framework_compatibility_matrix.xml
        framework_compatibility_matrix.xml
        framework_compatibility_matrix.xml
        framework_compatibility_matrix.xml
        framework_compatibility_matrix.xml
        framework_compatibility_matrix.xml
        framework_compatibility_matrix.xml
        vendor.samsung.hardware.authfw@1.0-matrix.xml
        tlc_payment_compatibility_matrix.xml
        tlc_blockchain_compatibility_matrix.xml
        vendor.samsung.hardware.tlc.iccc@1.0-matrix.xml
        vendor.samsung.hardware.tlc.snap@1.0-matrix.xml
        framework_compatibility_matrix.xml
        framework_compatibility_matrix.xml
        framework_compatibility_matrix.xml
        framework_compatibility_matrix.xml
        framework_compatibility_matrix.xml
        vendor.samsung.hardware.hqm@1.0-matrix.xml
        framework_compatibility_matrix.xml
        framework_compatibility_matrix.xml
        radio_framework_compatibility_matrix_ds.xml
        face_compatibility_matrix.xml
        framework_compatibility_matrix.xml
        framework_compatibility_matrix.xml
        framework_compatibility_matrix.xml
        framework_compatibility_matrix.xml
        framework_compatibility_matrix.xml
        framework_compatibility_matrix.xml
        framework_compatibility_matrix.xml
        framework_compatibility_matrix.xml
        vendor.samsung.hardware.tlc.hdm@1.1-matrix.xml
        vendor.samsung.hardware.tlc.ddar@1.0-matrix.xml
        framework_compatibility_matrix.xml
        framework_compatibility_matrix.xml
        framework_compatibility_matrix.xml
        device_framework_compatibility_matrix.xml
-->
<compatibility-matrix version="4.0" type="framework">
    <hal format="hidl" optional="true">
        <name>android.hardware.automotive.evs</name>
        <version>1.1</version>
        <interface>
            <name>IEvsEnumerator</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>android.hardware.biometrics.face</name>
        <version>1.0</version>
        <interface>
            <name>IBiometricsFace</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>android.hardware.gnss</name>
        <version>1.0-1</version>
        <version>2.0-1</version>
        <interface>
            <name>IGnss</name>
            <instance>default</instance>
            <instance>gnss_vendor</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>android.hardware.light</name>
        <interface>
            <name>ILights</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>android.hardware.media.c2</name>
        <version>1.0</version>
        <interface>
            <name>IComponentStore</name>
            <instance>default</instance>
            <instance>software</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>android.hardware.nfc</name>
        <version>1.0</version>
        <interface>
            <name>INfc</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>android.hardware.nfc</name>
        <version>1.2</version>
        <interface>
            <name>INfc</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>android.hardware.nfc</name>
        <version>1.2</version>
        <interface>
            <name>INfc</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>android.hardware.radio</name>
        <version>1.0-4</version>
        <interface>
            <name>IRadio</name>
            <instance>slot1</instance>
            <instance>slot2</instance>
        </interface>
        <interface>
            <name>ISap</name>
            <instance>slot1</instance>
            <instance>slot2</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>android.hardware.radio</name>
        <version>1.2</version>
        <interface>
            <name>ISap</name>
            <instance>slot1</instance>
            <instance>slot2</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>android.hardware.radio.config</name>
        <version>1.0-1</version>
        <interface>
            <name>IRadioConfig</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>android.hardware.secure_element</name>
        <version>1.2</version>
        <interface>
            <name>ISecureElement</name>
            <instance>eSE1</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>android.hardware.vibrator</name>
        <interface>
            <name>IVibrator</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>android.hardware.wifi.supplicant</name>
        <version>1.0-2</version>
        <interface>
            <name>ISupplicant</name>
            <instance>default</instance>
            <instance>wigigp2p</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>com.dsi.ant</name>
        <version>1.0</version>
        <interface>
            <name>IAnt</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>com.qualcomm.qti.dpm.api</name>
        <version>1.0</version>
        <interface>
            <name>IdpmQmi</name>
            <instance>dpmQmiService</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>com.qualcomm.qti.imscmservice</name>
        <version>2.0-2</version>
        <interface>
            <name>IImsCmService</name>
            <instance>qti.ims.connectionmanagerservice</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>com.qualcomm.qti.uceservice</name>
        <version>2.0-1</version>
        <version>2.2</version>
        <version>2.3</version>
        <interface>
            <name>IUceService</name>
            <instance>com.qualcomm.qti.uceservice</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>com.qualcomm.qti.wifidisplayhal</name>
        <version>1.0</version>
        <interface>
            <name>IDSManager</name>
            <instance>wifidisplaydshal</instance>
        </interface>
        <interface>
            <name>IHDCPSession</name>
            <instance>wifidisplayhdcphal</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>com.quicinc.cne.api</name>
        <version>1.0-1</version>
        <interface>
            <name>IApiService</name>
            <instance>cnd</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>com.quicinc.cne.server</name>
        <version>2.0-2</version>
        <interface>
            <name>IServer</name>
            <instance>cnd</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.display.color</name>
        <version>1.0-7</version>
        <interface>
            <name>IDisplayColor</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.display.config</name>
        <version>1.0-15</version>
        <version>2.0</version>
        <interface>
            <name>IDisplayConfig</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.display.postproc</name>
        <version>1.0</version>
        <interface>
            <name>IDisplayPostproc</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.nxp.hardware.nfc</name>
        <version>1.0-1</version>
        <version>2.0</version>
        <interface>
            <name>INqNfc</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.nxp.nxpnfclegacy</name>
        <version>1.0</version>
        <interface>
            <name>INxpNfcLegacy</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.automotive.qcarcam</name>
        <version>1.0</version>
        <interface>
            <name>IQcarCamera</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.data.factory</name>
        <version>1.0</version>
        <version>2.0-5</version>
        <interface>
            <name>IFactory</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.diaghal</name>
        <version>1.0</version>
        <interface>
            <name>Idiag</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.esepowermanager</name>
        <version>1.0-1</version>
        <interface>
            <name>IEsePowerManager</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.gnss</name>
        <version>1.0-2</version>
        <version>2.0-1</version>
        <version>3.0</version>
        <version>4.0-1</version>
        <interface>
            <name>ILocHidlGnss</name>
            <instance>gnss_vendor</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.gnss</name>
        <interface>
            <name>ILocAidlGnss</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.AGMIPC</name>
        <version>1.0</version>
        <interface>
            <name>IAGM</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.ListenSoundModel</name>
        <version>1.0</version>
        <interface>
            <name>IListenSoundModel</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.alarm</name>
        <version>1.0</version>
        <interface>
            <name>IAlarm</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.audiohalext</name>
        <version>1.0</version>
        <interface>
            <name>IAudioHalExt</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.bluetooth_audio</name>
        <version>2.0-1</version>
        <interface>
            <name>IBluetoothAudioProvidersFactory</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.cacert</name>
        <version>1.0</version>
        <interface>
            <name>IService</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.capabilityconfigstore</name>
        <version>1.0</version>
        <interface>
            <name>ICapabilityConfigStore</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.cryptfshw</name>
        <version>1.0</version>
        <interface>
            <name>ICryptfsHw</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.cvp</name>
        <version>1.0</version>
        <interface>
            <name>ICvp</name>
            <instance>cvphalservice</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.data.connection</name>
        <version>1.0-1</version>
        <interface>
            <name>IDataConnection</name>
            <instance>slot1</instance>
            <instance>slot2</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.data.iwlan</name>
        <version>1.0-1</version>
        <interface>
            <name>IIWlan</name>
            <instance>slot1</instance>
            <instance>slot2</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.data.latency</name>
        <version>1.0</version>
        <interface>
            <name>ILinkLatency</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.debugutils</name>
        <version>1.0</version>
        <interface>
            <name>IDebugUtils</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.display.allocator</name>
        <version>1.0</version>
        <version>3.0</version>
        <version>4.0</version>
        <interface>
            <name>IQtiAllocator</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.display.composer</name>
        <version>2.0-1</version>
        <version>3.0</version>
        <version>3.1</version>
        <interface>
            <name>IQtiComposer</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.hardware.display.config</name>
        <interface>
            <name>IDisplayConfig</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.display.demura</name>
        <version>1.0</version>
        <version>2.0</version>
        <interface>
            <name>IDemuraFileFinder</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.display.mapper</name>
        <version>2.0</version>
        <version>3.0</version>
        <version>4.0</version>
        <interface>
            <name>IQtiMapper</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.dpmservice</name>
        <version>1.0</version>
        <interface>
            <name>IDpmService</name>
            <instance>DpmService</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.dsp</name>
        <version>1.0</version>
        <interface>
            <name>IDspService</name>
            <instance>dspservice</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.eid</name>
        <version>1.0</version>
        <interface>
            <name>IEid</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.embmssl</name>
        <version>1.0-1</version>
        <interface>
            <name>IEmbms</name>
            <instance>embmsslServer0</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.factory</name>
        <version>1.0-1</version>
        <interface>
            <name>IFactory</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.fstman</name>
        <version>1.0</version>
        <interface>
            <name>IFstManager</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.improvetouch.blobmanager</name>
        <version>1.0</version>
        <interface>
            <name>IBlobManager</name>
            <instance>BlobManagerService</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.improvetouch.gesturemanager</name>
        <version>1.0</version>
        <interface>
            <name>IGestureManager</name>
            <instance>GestureManagerService</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.improvetouch.touchcompanion</name>
        <version>1.0</version>
        <interface>
            <name>ITouchCompanion</name>
            <instance>TouchCompanionService</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.iop</name>
        <version>2.0</version>
        <interface>
            <name>IIop</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.limits</name>
        <version>1.0-1</version>
        <interface>
            <name>ILimits</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.mwqemadapter</name>
        <version>1.0</version>
        <interface>
            <name>IMwqemAdapter</name>
            <instance>MwqemAdapter</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.pal</name>
        <version>1.0</version>
        <interface>
            <name>IPAL</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.perf</name>
        <version>2.0-3</version>
        <interface>
            <name>IPerf</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.power.powermodule</name>
        <version>1.0</version>
        <interface>
            <name>IPowerModule</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.qccsyshal</name>
        <version>1.0-1</version>
        <interface>
            <name>IQccsyshal</name>
            <instance>qccsyshal</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.qccvndhal</name>
        <version>1.0</version>
        <interface>
            <name>IQccvndhal</name>
            <instance>qccvndhal</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.qconfig</name>
        <version>1.0</version>
        <interface>
            <name>IQConfig</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.qdutils_disp</name>
        <version>1.0</version>
        <interface>
            <name>IQdutilsDisp</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.qseecom</name>
        <version>1.0</version>
        <interface>
            <name>IQSEECom</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.hardware.qxr</name>
        <interface>
            <name>IQXRCoreService</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.hardware.qxr</name>
        <interface>
            <name>IQXRCamService</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.hardware.qxr</name>
        <interface>
            <name>IQXRSplitService</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.hardware.qxr</name>
        <interface>
            <name>IQXRModService</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.hardware.qxr</name>
        <interface>
            <name>IQXRAudioService</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.radio.am</name>
        <version>1.0</version>
        <interface>
            <name>IQcRilAudio</name>
            <instance>slot1</instance>
            <instance>slot2</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.hardware.radio.am</name>
        <interface>
            <name>IQcRilAudio</name>
            <instance>slot1</instance>
            <instance>slot2</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.radio.ims</name>
        <version>1.0-8</version>
        <interface>
            <name>IImsRadio</name>
            <instance>imsradio0</instance>
            <instance>imsradio1</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.hardware.radio.ims</name>
        <version>1-3</version>
        <interface>
            <name>IImsRadio</name>
            <instance>imsradio0</instance>
            <instance>imsradio1</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.radio.internal.deviceinfo</name>
        <version>1.0</version>
        <interface>
            <name>IDeviceInfo</name>
            <instance>deviceinfo</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.radio.lpa</name>
        <version>1.0-2</version>
        <interface>
            <name>IUimLpa</name>
            <instance>UimLpa0</instance>
            <instance>UimLpa1</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.radio.qcrilhook</name>
        <version>1.0</version>
        <interface>
            <name>IQtiOemHook</name>
            <instance>oemhook0</instance>
            <instance>oemhook1</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.radio.qtiradio</name>
        <version>1.0</version>
        <version>2.0-6</version>
        <interface>
            <name>IQtiRadio</name>
            <instance>slot1</instance>
            <instance>slot2</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.hardware.radio.qtiradio</name>
        <interface>
            <name>IQtiRadioStable</name>
            <instance>slot1</instance>
            <instance>slot2</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.radio.uim</name>
        <version>1.1-2</version>
        <interface>
            <name>IUim</name>
            <instance>Uim0</instance>
            <instance>Uim1</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.radio.uim_remote_client</name>
        <version>1.0</version>
        <interface>
            <name>IUimRemoteServiceClient</name>
            <instance>uimRemoteClient0</instance>
            <instance>uimRemoteClient1</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.radio.uim_remote_server</name>
        <version>1.0</version>
        <interface>
            <name>IUimRemoteServiceServer</name>
            <instance>uimRemoteServer0</instance>
            <instance>uimRemoteServer1</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.scve.objecttracker</name>
        <version>1.0</version>
        <interface>
            <name>IObjectTracker</name>
            <instance>objectTracker</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.scve.panorama</name>
        <version>1.0</version>
        <interface>
            <name>IPanoramaStitching</name>
            <instance>panoStitching</instance>
        </interface>
        <interface>
            <name>IPanoramaTracking</name>
            <instance>panoTracking</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.seccam</name>
        <version>1.0</version>
        <interface>
            <name>ISecCam</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.servicetracker</name>
        <version>1.0-2</version>
        <interface>
            <name>IServicetracker</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.slmadapter</name>
        <version>1.0</version>
        <interface>
            <name>ISlmAdapter</name>
            <instance>SlmAdapter</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.soter</name>
        <version>1.0</version>
        <interface>
            <name>ISoter</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.sxrhal</name>
        <version>1.0</version>
        <interface>
            <name>ISxrCrypto</name>
            <instance>sxrhalservice</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.systemhelper</name>
        <version>1.0</version>
        <interface>
            <name>ISystemEvent</name>
            <instance>default</instance>
        </interface>
        <interface>
            <name>ISystemResource</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.trustedui</name>
        <version>1.0-2</version>
        <interface>
            <name>ITrustedInput</name>
            <instance>default</instance>
            <instance>qtee-vm</instance>
        </interface>
        <interface>
            <name>ITrustedUI</name>
            <instance>default</instance>
            <instance>qtee-vm</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.tui_comm</name>
        <version>1.0</version>
        <interface>
            <name>ITuiComm</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.wifi.hostapd</name>
        <version>1.0-3</version>
        <interface>
            <name>IHostapdVendor</name>
            <instance>default</instance>
            <instance>wigighostapd</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.wifi.supplicant</name>
        <version>2.0-3</version>
        <interface>
            <name>ISupplicantVendor</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.wifi.wificfr</name>
        <version>1.0</version>
        <interface>
            <name>IWificfr</name>
            <instance>wificfr</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.wifi.wifilearner</name>
        <version>1.0</version>
        <interface>
            <name>IWifiStats</name>
            <instance>wifiStats</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.wifi.wifimyftm</name>
        <version>1.0</version>
        <interface>
            <name>IWifiMyFtm</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.wifidisplaysession</name>
        <version>1.0</version>
        <interface>
            <name>IWifiDisplaySession</name>
            <instance>wifidisplaysession</instance>
        </interface>
        <interface>
            <name>IWifiDisplaySessionAudioTrack</name>
            <instance>wifidisplaysessionaudiotrack</instance>
        </interface>
        <interface>
            <name>IWifiDisplaySessionImageTrack</name>
            <instance>wifidisplaysessionimagetrack</instance>
        </interface>
        <interface>
            <name>IWifiDisplaySessionVideoTrack</name>
            <instance>wifidisplaysessionvideotrack</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.wipower</name>
        <version>1.0</version>
        <interface>
            <name>IWipower</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.ims.callinfo</name>
        <version>1.0</version>
        <interface>
            <name>IService</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.ims.factory</name>
        <version>1.0-1</version>
        <version>2.0</version>
        <interface>
            <name>IImsFactory</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.imsrtpservice</name>
        <version>3.0</version>
        <interface>
            <name>IRTPService</name>
            <instance>imsrtpservice</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.memory.pasrmanager</name>
        <version>1.0-1</version>
        <interface>
            <name>IPasrManager</name>
            <instance>pasrhal</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.mstatservice</name>
        <version>1.0</version>
        <interface>
            <name>IMStatService</name>
            <instance>mstatservice</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.power.pasrmanager</name>
        <version>1.0</version>
        <interface>
            <name>IPasrManager</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.qesdhal</name>
        <version>1.0-1</version>
        <interface>
            <name>IQesdhal</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.voiceprint</name>
        <version>1.0</version>
        <interface>
            <name>IQtiVoicePrintService</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.samsung.hardware.audio</name>
        <version>1.0</version>
        <interface>
            <name>ISehDevicesFactory</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.samsung.hardware.authfw</name>
        <version>1.0</version>
        <interface>
            <name>ISehAuthenticationFramework</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.samsung.hardware.biometrics.face</name>
        <version>2.0</version>
        <interface>
            <name>ISehBiometricsFace</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.samsung.hardware.bluetooth</name>
        <version>2.0</version>
        <interface>
            <name>ISehBluetooth</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.samsung.hardware.camera.provider</name>
        <version>4.0</version>
        <interface>
            <name>ISehCameraProvider</name>
            <instance>legacy/0</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.samsung.hardware.camera.provider</name>
        <version>4.0</version>
        <interface>
            <name>ISehCameraProvider</name>
            <regex-instance>[^/]+/[0-9]+</regex-instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.samsung.hardware.gnss</name>
        <version>2.0</version>
        <interface>
            <name>ISehGnss</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.samsung.hardware.gnss</name>
        <interface>
            <name>ISehGnss</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.samsung.hardware.health</name>
        <version>2.0</version>
        <interface>
            <name>ISehHealth</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.samsung.hardware.hqm</name>
        <version>1.0</version>
        <interface>
            <name>ISehHqm</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.samsung.hardware.hyper</name>
        <interface>
            <name>ISehHyPer</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.samsung.hardware.media.converter</name>
        <interface>
            <name>ISehColorConverterStore</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.samsung.hardware.media.converter</name>
        <interface>
            <name>ISehColorConverterStore</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.samsung.hardware.media.mpp</name>
        <interface>
            <name>ISehMppStore</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.samsung.hardware.miscpower</name>
        <version>2.0</version>
        <interface>
            <name>ISehMiscPower</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.samsung.hardware.nfc</name>
        <version>2.0</version>
        <interface>
            <name>ISehNfc</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.samsung.hardware.nfc</name>
        <version>2.0</version>
        <interface>
            <name>ISehNfc</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.samsung.hardware.radio</name>
        <version>2.2</version>
        <interface>
            <name>ISehRadio</name>
            <instance>slot1</instance>
            <instance>slot2</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.samsung.hardware.radio.bridge</name>
        <version>2.0</version>
        <interface>
            <name>ISehBridge</name>
            <instance>slot1</instance>
            <instance>slot2</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.samsung.hardware.radio.channel</name>
        <version>2.0</version>
        <interface>
            <name>ISehChannel</name>
            <instance>epdgd</instance>
            <instance>epdgd2</instance>
            <instance>imsd</instance>
            <instance>imsd2</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.samsung.hardware.security.drk</name>
        <version>2.0</version>
        <interface>
            <name>ISehDrk</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.samsung.hardware.security.engmode</name>
        <version>1.0</version>
        <interface>
            <name>ISehEngmode</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.samsung.hardware.security.hdcp.keyprovisioning</name>
        <version>1.0</version>
        <interface>
            <name>ISehHdcpKeyProvisioning</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.samsung.hardware.security.proca</name>
        <version>2.0</version>
        <interface>
            <name>ISehProca</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.samsung.hardware.security.proca</name>
        <version>2.0</version>
        <interface>
            <name>ISehProca</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.samsung.hardware.security.sem</name>
        <version>1.0</version>
        <interface>
            <name>ISehSem</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.samsung.hardware.security.skpm</name>
        <version>1.0</version>
        <interface>
            <name>ISehSkpm</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.samsung.hardware.security.vaultkeeper</name>
        <version>2.0</version>
        <interface>
            <name>ISehVaultKeeper</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="false">
        <name>vendor.samsung.hardware.security.widevine.keyprov</name>
        <version>1.0</version>
        <interface>
            <name>ISehWidevineKeyProvisioning</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.samsung.hardware.security.wsm</name>
        <version>1.0</version>
        <interface>
            <name>ISehWsm</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.samsung.hardware.security.wsm</name>
        <version>1.0</version>
        <interface>
            <name>ISehWsm</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.samsung.hardware.snap</name>
        <version>1.2</version>
        <interface>
            <name>ISehSnap</name>
            <instance>default</instance>
            <instance>secsnap</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.samsung.hardware.sysinput</name>
        <version>1.2</version>
        <interface>
            <name>ISehSysInputDev</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.samsung.hardware.sysinput</name>
        <version>1.2</version>
        <interface>
            <name>ISehSysInputDev</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.samsung.hardware.thermal</name>
        <version>1.0</version>
        <interface>
            <name>ISehThermal</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.samsung.hardware.tlc.blockchain</name>
        <version>1.0</version>
        <interface>
            <name>ISehBlockchain</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.samsung.hardware.tlc.ddar</name>
        <version>1.0</version>
        <interface>
            <name>ISehDdar</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.samsung.hardware.tlc.hdm</name>
        <version>1.1</version>
        <interface>
            <name>ISehHdm</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.samsung.hardware.tlc.iccc</name>
        <version>1.0</version>
        <interface>
            <name>ISehIccc</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.samsung.hardware.tlc.kg</name>
        <version>1.0</version>
        <interface>
            <name>ISehKg</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.samsung.hardware.tlc.payment</name>
        <version>1.0</version>
        <interface>
            <name>ISehTlcPayment</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.samsung.hardware.tlc.snap</name>
        <version>1.0</version>
        <interface>
            <name>ISehSnapSec</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.samsung.hardware.tlc.ucm</name>
        <version>2.0</version>
        <interface>
            <name>ISehUcm</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.samsung.hardware.wifi</name>
        <version>2.0-2</version>
        <interface>
            <name>ISehWifi</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.samsung.hardware.wifi.hostapd</name>
        <version>4.0</version>
        <interface>
            <name>ISehHostapd</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.samsung.hardware.wifi.supplicant</name>
        <version>3.0-1</version>
        <interface>
            <name>ISehSupplicant</name>
            <instance>default</instance>
        </interface>
    </hal>
    <sepolicy>
        <kernel-sepolicy-version>30</kernel-sepolicy-version>
        <sepolicy-version>26.0</sepolicy-version>
        <sepolicy-version>27.0</sepolicy-version>
        <sepolicy-version>28.0</sepolicy-version>
        <sepolicy-version>29.0</sepolicy-version>
        <sepolicy-version>30.0</sepolicy-version>
        <sepolicy-version>31.0</sepolicy-version>
    </sepolicy>
    <avb>
        <vbmeta-version>1.0</vbmeta-version>
    </avb>
</compatibility-matrix>
